#include <stdio.h>
#include <time.h>

#ifdef USE_THREAD_ALLOC
#include "threadalloc.h"
#endif

#include "sync.h"

#define N_ITERATIONS 300000
#define N_OBJECTS    100

semaphore_t consumer_sem(0);
semaphore_t producer_sem(1);
char* obj[N_OBJECTS];

void thread_proc consumer(void*) { 
    for (int i = 0; i < N_ITERATIONS; i++) { 	
	consumer_sem.wait();
	for (int j = 0; j < N_OBJECTS; j++) { 
	    delete[] obj[j];
	}
	producer_sem.signal();
    }
}

void thread_proc producer(void*) { 
    for (int i = 0; i < N_ITERATIONS; i++) { 	
	producer_sem.wait();
	for (int j = 0; j < N_OBJECTS; j++) { 
	    obj[j] = new char[j % 100];
	}
	consumer_sem.signal();
    }
}

int main(int argc, char* argv[]) 
{
#ifdef _WIN32
    if (argc > 1 && strcmp(argv[1], "-1") == 0) { 
	SetProcessAffinityMask(GetCurrentProcess(), 1);
    }
#endif
    thread_t consumer_thread;
    thread_t producer_thread;
    unsigned start = time(NULL);
    consumer_thread.start(&consumer, NULL);
    producer_thread.start(&producer, NULL);
    consumer_thread.join();
    producer_thread.join();
    printf("Elapsed time: %ld\n", time(NULL) - start);
    return 0;
}


